/*
* Programm HE_EAN.PRG
* 
* Ideen: Enthlt alle Prozeduren zum Handling von EAN-13 und PZN
*        inkl. Prfziffernrechnung
         * Lnderprfix  ARGE Pharma  PZN (6 St ohne PZ)  Prfziffer EAN             
         * 9 0           8 8 8 8      X X X X X X         P 
         *                 
         * Sonderregelung fr die Pharmawirtschaft: Die Betriebsnummer wird von 5 auf 4 Stellen gekrzt,
         * somit stehen 6 Stellen fr die Pharmazentralnummer zur Verfgung (die 7.Stelle der Pharmazentralnummer,
         * die Prfziffer nach Modulo 11 muss hier nicht bercksichtigt werden, die Prffunktion wird durch die EAN-Prfnummer erfllt).
         * 908888XXXXXXP 
* Autor: Hans Krasser
*/

*------------------------------------------------
function LINKS_PZN(cSuchStr1)
    * ergnzt bei einer PZN mit weniger als 7 Stellen die links fehlenden Nullen
    LOCAL i,cZeichen,nlang:=0
    LOCAL cNull:="0000000000000",cPZN6:=""
    
    FOR i:=1 to LEN(cSuchStr1)  && akzeptiert nur Zahlen
        IF substr(cSuchStr1,i,1) $ "0123456789"
            cPZN6+=substr(cSuchStr1,i,1)
        ENDIF 
    NEXT i    
    
    nlang:=LEN(cPZN6)
    IF nlang < 7
       cPZN6:=substr(cNull,1,7-nlang) + cPZN6
       * ergnze links fhrende Nullen bis Lnge 7 erreicht
    Endif       
Return cPZN6

*------------------------------------------------
function PZ_PZN(cPZN)
    * berechnet die Prfziffer einer PZN
    LOCAL n,i, cChar, cPZ:="",nSumme:=0
    
    FOR i := 1 to LEN(cPZN) 
        IF i <= 6       && unbekannt, wie lange der String ist!
            n:= VAL(  substr(cPZN,i,1)  )
            nSumme+=n*(i+1)         && 1. Ziffer mit 2 multipl
        ENDIF
    NEXT i
    cPZ:=STR( nSumme % 11, 1,0)
    *MsgInfo( "PZ von "+cPZN+" ist "+cPZ)
Return cPZ

******************************************
* EAN13                                  *
*-----------------------------------------------------------------------------*
* Function urspr. f. Open Office, angepasst fr HMG - Clipper
* von Hans Krasser am 17.08.2008 20:34:19  
* Wenn lPZ = .T. wird nur die Prfziffer zurckgegeben
Function ean13(chaine,lPZ)
  *V 1.0
  *Paramtres : une chaine de 12 chiffres
  *Retour : * une chaine qui, affiche avec la police EAN13.TTF, donne le code barre
  *         * une chaine vide si paramtre fourni incorrect

  LOCAL i:=checksum:=first:=0,cPZ:=cFirst:=ean1:=CodeBarre:="",tableA:=.T.
  LOCAL True:=.T., False:=.F.,lnurPZ
   
  IF lPZ = NIL
    lnurPZ:=.F.
  ELSE
    lnurPZ:=lPZ
  ENDIF
  * Vrifier qu'il y a 12 caractres
  If Len(chaine) = 12 
    *Et que ce sont bien des chiffres
    For i := 1 To 12
      If Asc(SUBSTR(chaine, i, 1)) < 48 .OR. Asc(SUBSTR(chaine, i, 1)) > 57 
        i = 0
        Exit 
      EndIf
    Next
    If i = 13 
      * Calcul de la cl de contrle
      For i = 2 To 12 Step 2
        checksum = checksum + Val(SUBSTR(chaine, i, 1))
      Next
      checksum = checksum * 3
      For i = 1 To 11 Step 2
        checksum = checksum + Val(SUBSTR(chaine, i, 1))
      Next
      cPZ:=STR(  ( 10 - checksum % 10) % 10  ,1,0 )
      chaine = chaine + cPZ
      * Le premier chiffre est pris tel quel, le deuxime vient de la table A
      CodeBarre = Left(chaine, 1) + Chr(65 + Val(SUBSTR(chaine, 2, 1)))
      first = Val(Left(chaine, 1))
      cFirst:=Left(chaine, 1)
      For i = 3 To 7
        tableA = False
        DO Case  
         Case i =3
           DO Case 
            Case cFirst $ "0123"
                tableA := True
            Endcase
         Case i =4
           DO Case 
           Case cFirst $ "0478"
             tableA := True
           Endcase
         Case i =5
           DO Case 
           Case cFirst $ "01459"
             tableA := True
           Endcase
         Case i =6
           DO Case 
           Case cFirst $ "02567"
             tableA := True
           Endcase
         Case i =7
           DO Case 
           Case cFirst $ "03689"
             tableA := True
           Endcase
        Endcase
        If tableA 
         CodeBarre := CodeBarre + Chr(65 + Val(SUBSTR(chaine, i, 1)))
        Else
         CodeBarre := CodeBarre + Chr(75 + Val(SUBSTR(chaine, i, 1)))
        EndIf
     Next
      CodeBarre := CodeBarre + "*"   && Ajout sparateur central
      For i := 8 To 13
        CodeBarre := CodeBarre + Chr(97 + Val(SUBSTR(chaine, i, 1)))
      Next
      CodeBarre := CodeBarre + "+"   && Ajout de la marque de fin
      
    ENDIF
  ENDIF
  
  IF lnurPZ
    ean13 := cPZ
  ELSE
    ean13 := CodeBarre
  ENDIF
  
RETURN ean13

*------------------------------------------------
function EAN13_PZ(cScreen, cText)
    * berprft einen EAN-13, wenn Prfziffer falsch, wird das Eingabefeld korrigiert
    Local cEan13,cPruefziffer:="?",l_nur_PZ:=.T.,_CR:=chr(13)+chr(10) 
    Local cEan12:=""
        
    cEan13:=GetProperty (cScreen,cText ,"Value" )
    DO Case
        Case len(cEan13)= 13
            cEan12:=LEFT(cEan13,12)
        Case len(cEan13)= 12     && kennt die Prfziffer nicht
            cEan12:=cEan13
    Endcase   
    cPruefziffer:=ean13(cEan12, l_nur_PZ)
    
    IF len(cEan13)= 13
        IF cPruefziffer <> right(cEan13,1)
            MsgStop(cEan13+" enthlt eine falsche Prfziffer"+_CR+;
              "Das Feld "+cScreen+"."+cText+" wird korrigiert", "richtig ist "+cPruefziffer)    
        Endif
    Endif
    IF len(cEan13)= 12
       MsgInfo("EAN13 wird mit Prfziffer ergnzt")    
    Endif    

    SetProperty (cScreen,cText ,"Value", cEan12+cPruefziffer )
Return Nil

