/*
* HE_REGAL.PRG - Programm fr Druck Regalettiketten in HERMES
* 
* Ideen:  Vorlage ist der Etikketendruck im Projekt "Leonardo"
* Autor: Hans Krasser
*/

********************************************************************************
*        ETIKETTENDRUCK
* ******************************************************************************

*-----------------------------------------------------------------------------*
procedure DR_Etiketten()
    LOCAL lSuccess
    PRIVATE A4_B_mm:=210,A4_H_mm:=297
    PRIVATE Etti_hoch:=30, Etti_breit:=80,d_ZRand:=0
    PRIVATE LO_Zeile:=LO_Spalte:=0, nRand_L:=nRand_R:=nRand_O:=nRand_U:=10
    
    SELECT PRINTER DIALOG TO lSuccess PREVIEW
    If lSuccess == .F.
        Return
    EndIf    
    
    START PRINTDOC 
    JOB_HEADER("REGALETIKETT PREIS")   
    ETI_HEADER()
    ETI_BODY()     
    ETI_FOOTER()
    END PRINTDOC
return
*-----------------------------------------------------------------------------*
procedure ETI_BODY()
    * erzeugt Regalettiketten fr JEDEN ARTIKEL mit PREISNDERUNG
    LOCAL dL:=dO:=3,cEan12:=""
    
    select AART
    set filter to
    go top 

    DO While !eof()
        @ LO_Zeile+  0, LO_Spalte+ 0 PRINT LINE  TO LO_Zeile+  0, LO_Spalte+Etti_breit PENWIDTH 0.1 
        @ LO_Zeile+  0, LO_Spalte+ 0 PRINT LINE  TO LO_Zeile+Etti_hoch, LO_Spalte PENWIDTH 0.1
        @ LO_Zeile+  0, LO_Spalte+Etti_breit PRINT LINE  TO LO_Zeile+Etti_hoch, LO_Spalte+Etti_breit PENWIDTH 0.1         
               
        @ LO_Zeile+dO, LO_Spalte+dL  PRINT AART->BEZK FONT "Arial" SIZE 10 
        @ LO_Zeile+dO, LO_Spalte+50 PRINT "Nr "+AART->EDVNR FONT "Arial" SIZE 10
        
        @ LO_Zeile+dO+5, LO_Spalte+dL  PRINT AART->BEZ1 FONT "Arial" SIZE 10                          

        @ LO_Zeile+dO+09, LO_Spalte+dL ;
            PRINT ean13(left(aart->EAN,12) ) FONT "Code EAN13" SIZE 35
        IF AART->VKP1 >= 10000
            @ LO_Zeile+dO+10, LO_Spalte+dL+35  PRINT str(AART->VKP1,9,2) FONT "Arial" SIZE 20
        ELSE
            @ LO_Zeile+dO+10, LO_Spalte+dL+35  PRINT str(AART->VKP1,7,2) FONT "Arial" SIZE 30        
        EndIf
        @ LO_Zeile+dO+22, LO_Spalte+dL+60  PRINT dtoc(AART->AE_DATUM) FONT "Arial" SIZE 10                          
        skip

        NAE_ETTI()                  && bereitet die Koordinaten fr nchstes Etikett vor
    Enddo
     
return
*-----------------------------------------------------------------------------*
procedure NAE_ETTI()
   * bereitet die Koordinaten fr nchstes Etikett vor    
    LOCAL mindest_Sp:=A4_B_mm-nRand_R-Etti_breit
    LOCAL mindest_Zei:=A4_H_mm-nRand_U-Etti_hoch

    LO_Spalte+=Etti_breit
    IF LO_Spalte > mindest_Sp           && nicht mehr genur Platz fr Etikett
        LO_Spalte= nRand_L              && neue Reihe Ettiketten anfangen
        
        LO_Zeile+=Etti_hoch
        IF LO_Zeile > mindest_Zei       && nicht mehr genug Platz f. Etti-Hhe
            ETI_FOOTER()                && Seitenvorschub
            ETI_HEADER()
        EndIf                
    EndIF
return nil
*-----------------------------------------------------------------------------*
procedure ETI_HEADER()
    * beginnt neues Etikettenblatt   
    START PRINTPAGE
    	
    LO_Zeile= nRand_O
    LO_Spalte= nRand_L    
return
*-----------------------------------------------------------------------------*
procedure ETI_FOOTER()
    * druckt ein volles Etikettenblatt fertig und Stellt auf Null
	END PRINTPAGE    
return
*-----------------------------------------------------------------------------*
function JOB_HEADER(cThema)
    * druck am Beginn eines Jobs eine Arbeitsanweisung aus
    LOCAL cThema1:=upper(cThema)

    ETI_HEADER()

    @  20, 10 PRINT "ORD. DR. KRASSER" FONT "Arial" SIZE 11 
    @  20,160  PRINT dtoc(date() )+"/"+time() FONT "Arial" SIZE 11                                   
    @  28,  8 PRINT LINE TO  28,200 PENWIDTH 0.1 
    @ 149,  8 PRINT LINE TO 149,12 PENWIDTH 0.3    && Lochermarke                         
           
    DO Case
      case cThema =="REGALETIKETT PREIS"
        @  50, 20 PRINT "REGALETIKETTEN - PREISNDERUNGEN" FONT "Arial" SIZE 25
        @  90, 20 PRINT "Bei diesen Artikeln hat sich der Verkaufspreis gendert." FONT "Arial" SIZE 16  
        @ 110, 20 PRINT "Bitte Regaletiketten ausschneiden und ersetzen" FONT "Arial" SIZE 16
        @ 130, 20 PRINT "(rechts unten steht Datum der letzten nderung)" FONT "Arial" SIZE 16
      otherwise
        @  50, 20 PRINT "PROGRAMMFEHLER" FONT "Arial" SIZE 20 
        @  70, 20 PRINT "function JOB_HEADER() in  HE_REGAL.PRG" FONT "Arial" SIZE 14             
    Endcase
    
    ETI_FOOTER()        
return .f.
*-----------------------------------------------------------------------------*
function JOB_HEADER1(aThema)
    * erledigt die eigentliche Druckarbeit
    LOCAL nlang:=LEN(aThema),i,nZeilenAbst:=20
    
    ETI_HEADER()
       
    For i:= 1 to nlang
msgInfo(str(i,3)+" "+VALTYPE(aThema[i]) )    
        @ i*nZeilenAbst, 10  PRINT aThema[i] FONT "Arial" SIZE 20           
    Next i
    @ 200,160  PRINT dtoc(date() )+"/"+time() FONT "Arial" SIZE 10 
       
    ETI_FOOTER()  
return .f.
*-----------------------------------------------------------------------------*
procedure DR_DB_Zeile()
   * druckt eine Zeile Grafik aus, wenn angefordert auch mehrfach
   LOCAL i,nPenwidth:=0.1

   FOR i = 10 TO 100 STEP 10
      nPenwidth = IIF(  INT(i/50 ) = i/50, 0.5, 0.1 )
      @ i,10 PRINT LINE  TO i,100 PENWIDTH nPenwidth
   NEXT i

   FOR i = 10 TO 100 STEP 10
      nPenwidth = IIF(  INT(i/50 ) = i/50, 0.5, 0.1 )
      @ 10,i PRINT LINE  TO 100,i PENWIDTH nPenwidth
   NEXT i
return nil
