/*
* Programm fr HE_WARTUNG.prg
* 
* Ideen: Bernahme Artikleldaten aus PLMED von Richter, regelmige
*        Wartung der Preise PLMED.DBF ->HERMES
* Autor: Hans Krasser
*/

Function WA_RI_PLM()
    LOCAL x

    select AART    
    set order to 1      && index on EDVNR      to (cm_Pfad_DBF+"AART")
    
    HOLE_PLMED()
    IF !PLMED_AUF()     && ist in HE_DATEI.PRG
        MsgStop("Derzeit KEIN  Zugrifff auf PLMED.DBF mglich")
        Return
    EndIf
    PL_AKTIV()          && markiert die Artikel mit PLMED->HK="J" fr die gilt
                        *  AART-> LISTKZ = "J" 
    PL_BROWSE()         && Suchfunktion, bei DbClick Maske fr bernahme:
                        *  Window PLMED_AART
    
    select PLMED
    use
    select AART

Return .F.
*-----------------------------------------------------------------------------
Function HOLE_PLMED()
    MsgStop("Hier fehlt Modul: Wenn Zugrifff auf Laptop in ffentlichem Verzeichnis, wird PLMED.DBF auf diesen Rechner kopiert")
Return .F.
 
********************************************************************************
*   WA_RI_PLM()                                                                *
*   bernahme von definierten Artikel der Fa. Richter in Artikelstamm          *
********************************************************************************
Function PL_BROWSE()
    PRIVATE bColor := { || if ( upper(PLMED->HK)="J" , { 119,250,120 } , { 255,255,255 } ) }   
    select PLMED
    set order to 2      && set index to PLMED,PLMED_KT
    go top
    
   define window plbrowse1 at 0, 0 width 1200 height 700 title 'bernahme PLMED-Daten von Fa. Richter' child

   *----------------------------------
    @50,10 BROWSE BROWSE_PL ;
    WIDTH 1150 ;
    HEIGHT 600 ;
    HEADERS { 'LIST' , 'TN' , 'V_CODE' , 'GUELTIG' , 'HS' , 'AE' , 'KP' , 'PM' , 'RZ' , 'KT' , 'MG' , 'MA' , 'KZ1' , 'KZ2' , 'MW'} ;
    WIDTHS {   50, 70,  20, 50, 60, 75, 75, 75, 40,250, 60, 30, 40, 40, 40} ;
    WORKAREA PLMED ;
    FIELDS { 'PLMED->HK' , 'PLMED->TN' , 'PLMED->V_CODE' , 'PLMED->GUELTIG' , 'PLMED->HS' , 'PLMED->AE' , 'PLMED->KP' , 'PLMED->PM' , 'PLMED->RZ' , 'PLMED->KT' , 'PLMED->MG' , 'PLMED->MA' , 'PLMED->KZ1' , 'PLMED->KZ2' , 'PLMED->MW'} ;
    DYNAMICBACKCOLOR { bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor } ;    
    ON DBLCLICK PL_TRANS1();
    LOCK
     
    plbrowse1.BROWSE_PL.Value := recno()
   *-----------------------------------
   *plmed_Art_Wartung 
   	    DEFINE BUTTON BUTTON1
		  ROW	10
		  COL	500
		  CAPTION	'Hilfe - Transfer'
		  ACTION	HELP_PLMED()
		  WIDTH	150
	   END BUTTON
		DEFINE LABEL Label_1
			ROW	10
			COL	10
			WIDTH	60
			VALUE 'Suchtext:'
		END LABEL

		DEFINE TEXTBOX Text_1
			ROW	10
			COL	80
			WIDTH	150
			ON ENTER SUCHE_KT()
		END TEXTBOX
		
		DEFINE BUTTON Button_A
			ROW	10
			COL	240
			WIDTH	100
			CAPTION	'SUCHEN'
			ACTION	SUCHE_KT()
		END BUTTON              
   END WINDOW
   plbrowse1.center
   plbrowse1.activate
Return
*-------------------------------------------------------------------------------
function SUCHE_KT()
Local cSuchstr:=rtrim(  upper(plbrowse1.Text_1.Value)  )
Local nRecord_No:= recno()

	seek cSuchstr
	IF found()
	   *MsgInfo("Suchtext "+Form_1.Text_1.Value + "vorhanden " , "Suchen nach Artikelbezeichnung")
	
        *Form_1.Grid_1.EnableUpdate()
        plbrowse1.BROWSE_PL.Value := recno()      
	Else
        MsgStop("Suchtext "+cSuchstr + "nicht gefunden " , "Suchen nach Artikelbezeichnung") 
        go nRecord_No	
	Endif
	plbrowse1.BROWSE_PL.refresh
    plbrowse1.BROWSE_PL.SetFocus	
	
Return .F.
*-------------------------------------------------------------------------------
function HELP_PLMED()
    *EXECUTE FILE "plmed_Art_Wartung.pdf" 
Return Nil
*-------------------------------------------------------------------------------
function PL_TRANS1()
    LOCAL i:=0,cTN := plmed->TN
    PRIVATE aValid:={"STK","PCK","KAR","PAL","M ","L ","ML "},l_neueDaten:=.F.,aRows [30] [9]
    PRIVATE aMWSt:={"1","2","3"},aRaum:={"VERBAND","LABOR","ANMELD","APOTH","ARZT1","ARZT2","SERVER","SOZIAL","TECHNIK"}
 
    aRows [1]	:= {"","","","","","","","",""}
    IF IsWindowActive(PLMED_AART)
        RELEASE WINDOW PLMED_AART
    ENDIF
    Load Window PLMED_AART
    * Laden des DB Felder in den Schirm-------------    
    select AART
    seek cTN+"00"           && AART->EDVNR C  9, TN von PLMED linksbndig, re "00"
    IF found()
        PLMED_AART.Text_7.Value  := AART->EAN
        PLMED_AART.Text_21.Value := AART->EI_DATUM 
        PLMED_AART.Text_4.Value  := AART->BEZK
        PLMED_AART.Text_35.Value  := AART->EAN_DRUCK 
        PLMED_AART.Text_31.Value  := AART->LAGERRAUM
        PLMED_AART.Text_32.Value  := AART->LAGER_REG
        PLMED_AART.Text_32.Value  := AART->LAGER_REG 
        PLMED_AART.Text_9.Value := AART->BEDARF                     
    Else
        PLMED_AART.Text_21.Value := DATE() 
        PLMED_AART.Text_35.Value  :="N"
        PLMED_AART.Text_9.Value := 1                                             
    EndIf
    PLMED_AART.Text_11.Value := PLMED->MG+" "+PLMED->MA+space(5)+PLMED->KZ1+"/"+PLMED->KZ2    
     
    PLMED_AART.Text_10.Value := PLMED->KT
    PLMED_AART.Text_15.Value := "J"         && als AART->LISTKZ gespeichert    
    PLMED_AART.Text_18.Value := PLMED->MW
    PLMED_AART.Text_8.Value := PLMED->AE
    PLMED_AART.Label_15.Value :="Rohaufschlag ?????"
    IF PLMED->MW $ "123"
        i = val(PLMED->MW)                  && USt_Satz:={ 20,10, 0} 
        PLMED_AART.Text_12.Value := PLMED->AE*( 1+(USt_Satz[i]/100) )

        PLMED_AART.Label_12.Value := str(USt_Satz[i], 3,0)+"%"
        IF PLMED->AE > 0                    &&           VK_BTTO     MWST_Faktor            EK_NTTO
            PLMED_AART.Label_15.Value :="Rohaufschlag "+ str( (PLMED->PM/( 1+(USt_Satz[i]/100)) )/PLMED->AE,4,2 )
        Endif
    Else
        PLMED_AART.Text_12.Value := 0.01
        PLMED_AART.Label_12.Value := "?? %"        
    EndIf           
    PLMED_AART.Text_26.Value := PLMED->PM
    PLMED_AART.Text_33.Value := "N"

    
    PLMED_AART.Text_1.Value := cTN+"00"    
    PLMED_AART.Text_20.Value := DATE()    
    PLMED_AART.Text_2.Value := "R"

    * SAV_PL_AART():
    * Anlegen/ ndern ALIA-Satz wenn "SPEICHERN" gedrckt wird" 
    * MELG, MEVK, PCKVK werden vorerst alle auf "STK" gesetzt!        

    Activate Window PLMED_AART
Return (.F.)
*-------------------------------------------------------------------------------
function SAV_PL_AART()
    LOCAL cEdvNr:=PLMED_AART.Text_1.Value,lNew:=.F.
    
    select AART
    set order to 1          && set index to (cm_Pfad_DBF+"AART"), (cm_Pfad_DBF+"AART_MC"),(cm_Pfad_DBF+"AART_LA"),(cm_Pfad_DBF+"AART_HG"),(cm_Pfad_DBF+"AART_EAN")
    seek cEdvNr
    If !found()
      dbAppend()
      lNew:=.T.
      IF NETERR()
          MsgInfo( "Derzeit ist die Datei AART.DBF gesperrt, Anfgen von Daten nicht mglich")
          RELEASE WINDOW PLMED_AART
          select PLMED
          return
      ENDIF
    Endif
    
    IF RLOCK()
        IF lNew
            aart->EDVNR:=cEdvNr
            AART->EI_DATUM:=PLMED_AART.Text_21.Value        
        EndIf

        AART->EAN:=PLMED_AART.Text_7.Value 
 
        AART->BEZK:=upper(PLMED_AART.Text_4.Value)
        AART->EAN_DRUCK:=IIF( upper(PLMED_AART.Text_35.Value)$"JN",upper(PLMED_AART.Text_35.Value),"N" )
        AART->LAGERRAUM:=upper(PLMED_AART.Text_31.Value)
        AART->LAGER_REG:=upper(PLMED_AART.Text_32.Value) 
        AART->BEDARF:=PLMED_AART.Text_9.Value                    

        AART->BEZ2:=PLMED_AART.Text_11.Value        
        AART->BEZ1:=PLMED_AART.Text_10.Value
        AART->LISTKZ:=PLMED_AART.Text_15.Value  && als AART->LISTKZ gespeichert    
        AART->MWST:=PLMED_AART.Text_18.Value    && PLMED->MW

         
        AART->VKP1:=PLMED_AART.Text_26.Value  && PLMED->PM
        AART->KEIN_RAB:=PLMED_AART.Text_33.Value

        AART->AE_DATUM:=PLMED_AART.Text_20.Value    
        AART->K1F:="R"                          && PLMED_AART.Text_2.Value
        AART->NEU:="*"        

      UNLOCK

    ELSE
      MsgInfo( "Derzeit ist der Datensatz gesperrt, nderungen nicht mglich")
      RELEASE WINDOW PLMED_AART
      select PLMED      
      return
    ENDIF
    * ALIA ***************************************************************

    select ALIA
    set order to 1          && index on EDVNR+LNR
    seek cEdvNr+cRichterLnr
    If !found()
      dbAppend()
      lNew:=.T.
      IF NETERR()
          MsgInfo( "Derzeit ist die Datei ALIA.DBF gesperrt, Anfgen von Daten nicht mglich")
          RELEASE WINDOW PLMED_AART
          select PLMED
          return
      ENDIF
    Endif 
    
    IF RLOCK()
        IF lNew
            alia->EDVNR:=cEdvNr
            alia->LNR:=cRichterLnr
            alia->EI_DATUM:=PLMED_AART.Text_21.Value        
        EndIf
        alia->BNR:=left(cEdvNr,7)
        alia->P_VERGL:="00001.0000"
        alia->LISTKZA:="J"
        alia->EKP1:=PLMED_AART.Text_8.Value
      UNLOCK
      MsgInfo('PLMED-Daten wurden in AART und ALIA gespeichert')
    ELSE
      MsgInfo( "Derzeit ist der Datensatz gesperrt, nderungen nicht mglich")
      RELEASE WINDOW PLMED_AART
      select PLMED      
      return
    ENDIF 
    
    select PLMED 
    plmed->HK:="J"  
    RELEASE WINDOW PLMED_AART
    plbrowse1.setfocus
    plbrowse1.BROWSE_PL.refresh                             
Return (.F.)
*-------------------------------------------------------------------------------
function PL_AKTIV()
* markiert die Artikel mit PLMED->HK="J" fr die gilt AART-> LISTKZ = "J"
* AART->EDVNR C  9, enthlt die PLMED->TN linksbndig wenn AART->K1F = "R"
    LOCAL cEdvNr7
    
    select PLMED
    set order to 1      && set index to PLMED,PLMED_KT 
    replace all HK with space(1)       && ev. wurden Artikel inaktiv gesetzt   
    
    select aart
    go top
    Do While !eof()
        IF "R" $ upper (AART->K1F)
            IF upper(AART-> LISTKZ )= "J"
                cEdvNr7 = Left(AART->EDVNR,7)
                
                select plmed
                seek cEdvNr7
                If found()
                    plmed->HK:="J"
                EndIf
                
                select aart
            EndIf
        EndIf
        skip
    Enddo   
    MsgInfo('markiert die Artikel mit PLMED->HK="J" fr die gilt AART-> LISTKZ = "J"')
Return (.F.)

********************************************************************************
*   WA_RI_VKP()                                                                *
*   Wartung der Preise PLMED.DBF ->HERMES                                      *
********************************************************************************
function WA_RI_VKP()
    PRIVATE nFehler:=0,cFehler:=""
    IF IsWindowActive(PLMED_VKP)
        RELEASE WINDOW PLMED_VKP
    ENDIF
    Load Window PLMED_VKP
    
    Activate Window PLMED_VKP
Return (.F.)
*-------------------------------------------------------------------------------
function PLMED_VKP1()

    IF plmed_vkp.Check_2.value = .T.
        IF MsgYesNo("Sollen die Markierungen fr Preisnderungen in AART wirklich zurckgesetzt werden ?")
            select AART
            replace all NEU with space(1)
            MsgInfo("die Markierungen fr Preisnderungen in AART wurden zurckgesetzt")
        Else
            MsgInfo("die Markierungen fr Preisnderungen in AART bleiben unverndert")
        EndIf    
    EndIf
    
    HOLE_PLMED()
    IF !PLMED_AUF()     && ist in HE_DATEI.PRG
        MsgStop("Derzeit KEIN  Zugrifff auf PLMED.DBF mglich")
        Return
    EndIf
    wait_1()
    wait_e()
    plmed_vkp.Check_2.backcolor:={0,255,0}
    
    PLMED_VKP2()         && Alle Richter-Artikel werden abgeglichen
    wait_1()
    wait_e()
    IF nFehler = 0    
        plmed_vkp.Check_3.backcolor:={0,255,0}
    EndIf
    

    wait_1()
    wait_e()
    IF nFehler = 0  
        VKP_LIST1()     && druckt Liste aller Artikel die aktiv und VKP haben  
        plmed_vkp.Check_4.backcolor:={0,255,0}
    EndIf
    
    select PLMED
    use
    select AART

    IF nFehler = 0
        MsgInfo('Datentransfer PLMED-> Hermes erfolgreich abgeschlossen')
    Else
        MsgStop("Fehler bei Preiswartung: "+cFehler)
    EndIf
    RELEASE WINDOW PLMED_VKP
Return (.F.)
*-------------------------------------------------------------------------------
function PLMED_VKP2()
* Sucht ALLE Artikel in AART, egal wie das  AART-> LISTKZ ausheprgt ist
* AART->EDVNR C  9, enthlt die PLMED->TN linksbndig wenn AART->K1F = "R"
    LOCAL cEdvNr:=cEdvNr7:="",lNew:=.T.

    select PLMED
    set order to 1      && set index to PLMED,PLMED_KT 
           
    select aart
    go top
    Do While !eof()
        IF "R" $ upper (AART->K1F)      && enthlt die PLMED->TN linksbndig
            cEdvNr7 = Left(AART->EDVNR,7)
            cEdvNr = AART->EDVNR
                
            select plmed
            seek cEdvNr7
            If found()
                * ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
                select aart                
                IF RLOCK()
                    AART->BEZ2:=PLMED->MG+" "+PLMED->MA+space(5)+PLMED->KZ1+"/"+PLMED->KZ2       
                    AART->BEZ1:=PLMED->KT 
                    IF PLMED->MW $ "123"
                        AART->MWST:=PLMED->MW
                    Else
                        AART->MWST:="1"
                        AART->BEZ2:="*** falsche MWSt von Richter ***"                   
                    EndIf
                    IF ABS(AART->VKP1 -PLMED->PM)> 0.009
                        aart->NEU:="*"
                        AART->VKP1:=PLMED->PM                        
                    ENDIF
                    AART->AE_DATUM:=Date()          
                    UNLOCK
                ELSE
                    nFehler++
                    cFehler:="RLOCK-AART"
                    return
                ENDIF
                * ALIA ******************************************
                lNew:=.F.
                select ALIA
                set order to 1          && index on EDVNR+LNR
                seek cEdvNr+cRichterLnr
                If !found()
                    dbAppend()
                    lNew:=.T.
                    IF NETERR()
                        nFehler++
                        cFehler:="RLOCK-ALIA"
                        return
                    ENDIF
                Endif 
    
                IF RLOCK()
                    IF lNew
                        alia->EDVNR:=cEdvNr
                        alia->LNR:=cRichterLnr
                        alia->EI_DATUM:=Date() 
                        alia->BNR:=left(cEdvNr,7)
                        alia->P_VERGL:="00001.0000"
                        alia->LISTKZA:="J"                               
                    EndIf

                    alia->EKP1:=PLMED->AE
                    UNLOCK

                ELSE
                    nFehler++
                    cFehler:="RLOCK-ALIA"
                    return
                ENDIF                                
                * ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::                                
            EndIf
                
            select aart
        EndIf
        skip
    Enddo   

Return (.F.)
*************************************************
*  ARTIKELLISTE - SYSTEMATISCH nach HG-UG
*  druckt Liste aller Artikel die aktiv und VKP haben, Preisnderung = '*'
*------------------------------------------------
function VKP_LIST1()
    select AART   
    set order to 4      && index on HG+UG+upper(BEZK)  
    set filter to LISTKZ = "J" && .and. VKP1 > 0
    go top        
	DO REPORT ;
		TITLE		'Liste AKTIVE Drogeriewaren | Sort: HG+UG, Preisnderung = *'			;
		HEADERS		{'','','','','','','PREIS'} , {'HG','UG','Edvnr','','BEZEICHNUNG','VKP','ND'}	;
		FIELDS		{'HG','UG','Edvnr','NEU','BEZ1','VKP1','NEU'}				;
		WIDTHS		{2,2,9,1,39,8,5}			;
		TOTALS		{.F.,.F.,.F.,.F.,.F.,.F.,.F.}						;
		NFORMATS	{'','','','','','9999.99',''}					;
		WORKAREA	AART								;
		LPP		60								;
		CPL		80								;
		LMARGIN		3								;
		PAPERSIZE	DMPAPER_A4							;
		PREVIEW										; 
		SELECT										;
		MULTIPLE									;
		GROUPED BY	'HG'								;
		HEADRGRP	'HG'
        
        set order to 1 
        set filter to           
Return Nil
*-------------------------------------------------------------------------------
procedure wait_1()

	WAIT WINDOW "Bitte warten..."  NOWAIT
	inkey(2)

return
*-------------------------------------------------------------------------------
procedure wait_e()

	WAIT CLEAR

return

